CON
  _CLKMODE      = xtal1 + pll16x
  _XINFREQ      = 5_000_000
  DEBUG_PORT    = 0
  DEBUG_RX_PIN  = 15
  DEBUG_TX_PIN  = 14
  ADC_DIO_PIN   = 2
  ADC_CLK_PIN   = 1
  ADC_CS_PIN    = 3
  ADC_MODE      = %11111111
  CR            = 13

OBJ
  uarts         : "pcFullDuplexSerial4FC"
  imu           : "TwoCogIMU"
  floatString   : "FloatString"
  floatMath     : "floatMath"

VAR


PUB main
  uarts.addPort(DEBUG_PORT, DEBUG_RX_PIN, DEBUG_TX_PIN, UARTS#PINNOTUSED, UARTS#PINNOTUSED, UARTS#DEFAULTTHRESHOLD, UARTS#NOMODE,UARTS#BAUD115200)
  uarts.start
  imu.start(ADC_DIO_PIN, ADC_CLK_PIN, ADC_CS_PIN,  ADC_MODE)
  mainLoop

PUB mainLoop | reportTimer, reportPeriod
  reportTimer := cnt
  reportPeriod := clkfreq / 15
  repeat
    if (cnt - reportTimer) > reportPeriod
      sendReportPacket
      reportTimer := cnt

PUB sendReportPacket | temp
    uarts.tx(DEBUG_PORT, CR)
    uarts.dec(DEBUG_PORT, imu.xAxis)
    uarts.tx(DEBUG_PORT, ",")
    uarts.dec(DEBUG_PORT, imu.yAxis)
    uarts.tx(DEBUG_PORT, ",")
    uarts.dec(DEBUG_PORT, imu.zAxis)
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.unfilteredPitch,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.pitch,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.unfilteredPitchRate,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.unfilteredRoll,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.roll,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.str(DEBUG_PORT, floatString.floatToFormat(imu.unfilteredRoll,6,1))
    uarts.tx(DEBUG_PORT, ",")
    uarts.dec(DEBUG_PORT, imu.frequency)

